<template>
  <base-page class="items">
    <div class="page-header">
      <div class="row align-items-center">
        <div class="col">
          <h3 class="page-title">Ordenes</h3>
          <ul class="breadcrumb">
            <li class="breadcrumb-item">
              <router-link to="/admin/dashboard">{{
                $t('general.home')
              }}</router-link>
            </li>
            <li class="breadcrumb-item active">ordenes</li>
          </ul>
        </div>
        <div class="col-auto">
         <router-link v-if="isVendedor || isSuperAdmin" to="ventas/create" class="btn btn-primary mr-1">
            <i class="fas fa-plus"></i>
          </router-link>
          <a
            id="filter_search"
            class="btn btn-primary filter-btn"
            @click="toggleFilter(1)"
          >
            <i class="fas fa-filter"></i>
          </a>
        </div>
      </div>
    </div>
    <!-- Search Filter -->
    <div v-show="showFilters" class="card filter-card">
      <div class="card-body pb-0">
        <div class="row">
          <div class="col-sm-6 col-md-3">
            <div class="form-group">
              <label>Codigo</label>
              <input
                v-model="filters.codigo"
                type="text"
                class="form-control"
              />
            </div>
          </div>
          <div class="col-sm-6 col-md-3">
            <div class="form-group">
              <label>Nombre</label>
              <input
                v-model="filters.nombre"
                type="text"
                class="form-control"
              />
            </div>
          </div>
          <div class="col-sm-6 col-md-3">
            <div class="form-group">
              <label>Marca</label>
              <input v-model="filters.marca" type="text" class="form-control" />
            </div>
          </div>
          <div class="col-sm-6 col-md-3">
            <div class="form-group">
              <label>Estatus</label>
              <input v-model="filters.status" type="text" class="form-control" />
            </div>
          </div>
        </div>
      </div>
      <div>
        <label
          class="absolute text-sm leading-snug text-black cursor-pointer text-danger"
          style="top: 10px; right: 15px; position: absolute"
          @click="clearFilter"
          >{{ $t('general.clear_all') }}</label
        >
      </div>
    </div>
    <!-- /Search Filter -->
    <div class="row">
      <div class="col-sm-12">
        <base-loader v-if="isRequestOngoing" :show-bg-overlay="true" />
        <div class="custom_Card">
          <div class="card card-table">
            <div class="card-body">
              <div class="table-responsive">
                <vuetable
                  ref="vuetable"
                  :api-mode="false"
                  :fields="fields"
                  :per-page="perPage"
                  :sort-order="sortOrder"
                  :no-data-template="
                    showNomessage ? 'No hay registros' : ''
                  "
                  :data-manager="dataManager"
                  :css="css.table"
                  pagination-path="pagination"
                  @vuetable:pagination-data="onPaginationData"
                >
                  <template slot="name" slot-scope="props" @onclick="codigoBarra()">
                    {{ props.rowData.id }}
                  </template>
                  <template :slot="$t('ventas.action')" slot-scope="props" >
                    <div class="table-button-container">
                        	<router-link v-if="isVendedor || isSuperAdmin" class="btn btn-sm btn-white text-success mr-2" :to="`ventas/${props.rowData.id}/edit`"><i class="far fa-edit mr-1"></i> Actualizar  Orden/Producto</router-link>
                          <button v-if="!isVendedor && !isExpedicion && !isSuperAdmin" @click="updateOrder(props.rowData.id)" :loading="isLoading" :disabled="isLoading" class="btn btn-sm btn-white text-danger mr-2"><i  v-if="isLoading" class="fas fa-spinner fa-spin"></i>{{button}} </button>                     
                          <router-link v-if="isExpedicion && props.rowData.status!='Entregado'" class="btn btn-sm btn-white text-success mr-2" :to="`ventas/${props.rowData.id}/edit`"><i class="far fa-edit mr-1"></i> Validar código de barra</router-link>

                          </div>
                    </template>
                </vuetable>
                <vuetable-pagination
                  ref="pagination"
                  :css="css.pagination"
                  @vuetable-pagination:change-page="onChangePage"
                ></vuetable-pagination>
              </div>
              
            </div>
          </div>
        </div>
      </div>
    </div>
  </base-page>
</template>

<script>
import { mapActions, mapGetters} from 'vuex'
import CssForBootstrap4 from '../../tablestyle/tablestyle'

export default {
  data() {
    return {
      id: null,
      showFilters: false,
      sortedBy: 'created_at',
      isRequestOngoing: true,
      perPage: 10,
      page: 1,
      showNomessage: false,
      isLoading:false,
      button:'Actualizar Orden',
      sortOrder: [
        {
          field: 'created_at',
          sortField: 'created_at',
          direction: 'desc',
        },
      ],
      totalCount: 0,
      ventasList: [],
      css: CssForBootstrap4,
      filters: {
        codigo: '',
        nombre: '',
        marca: '',
        status:'',
      },
      fields: [
        {
          name: 'codigo',
          title: 'Codigo',
          sortField: 'codigo',
        },
        {
          name: 'nombre',
          title: 'Producto',
          sortField: 'nombre',
        },
        {
          name: 'marca',
          title: 'Sku',
          sortField: 'marca',
        },
        {
          name: 'precio1',
          title: 'Precio',
          sortField: 'precio1',
        },
        {
          name: 'observa',
          title: 'Observacion',
          sortField: 'observa',
        },
        {
          name: 'status',
          title: 'Estatus',
          sortField: 'status',
        },
        this.$t('ventas.action')
      ],
    }
  },
  computed: {
    ...mapGetters('user', ['currentUser']),

    /*...mapGetters('venta', ['currentVenta']),
    ...mapGetters('venta', [
      'ventas',
      'selectedVentas',
      'totalVentas',
      'selectAllField',
    ]),*/
    isSuperAdmin() {
      return this.currentUser.role == 'super admin'
    },
    isVendedor() {
      return this.currentUser.roles == 'Vendedor'
    },
    isExpedicion(){
      return this.currentUser.roles == 'Expedicion'

    },
    showEmptyScreen() {
      return !this.totalVentas && !this.isRequestOngoing
    },

    filterIcon() {
      return this.showFilters ? 'x-icon' : 'filter-icon'
    },

    selectField: {
      get: function () {
        return this.selectedVentas
      },
      set: function (val) {
        this.selectedVentas(val)
      },
    },

    selectAllFieldStatus: {
      get: function () {
        return this.selectAllField
      },
      set: function (val) {
        this.setSelectAllState(val)
      },
    },
  },
  mounted() {
    //setInterval(this.fetchVentas(), 5000);
  },
  created() {
    //this.fetchData(this.page, this.sortOrder)
    setInterval(this.fetchData,5000,this.page, this.sortOrder)

    /*if (!this.isSuperAdmin) {
      this.$router.push('/admin/dashboard')
    }*/
    console.log('Roles',this.currentUser.roles)
    if(this.currentUser.roles=='Vendedor'){
      this.button='Editar Orden'
    }
    if(this.currentUser.roles=='Cajero'){
      this.button='Facturar'
    }
    if(this.currentUser.roles=='Expedicion'){
      this.button='Entregar'
    }
    /*if(this.currentUser.roles=='Admin'){
      console.log('list',this.ventasList)
      this.ventasList.forEach(value=>{
        console.log('foreach',value)
        if(value.status=='Sin Ordenes'){
          this.button='Crear Orden'
        }
        if(value.status=='Orden Creada'){
          this.button='Facturar'
        }
        if(value.status=='Facturado'){
          this.button='Entregar'
        }
      })
    }*/

  },
  watch: {
    filters: {
      handler: _.debounce(function () {
        this.refreshTable()
      }, 1000),
      deep: true,
    },
    ventasList(newVal, oldVal) {
      console.log('filtro',this.$refs.vuetable)
      this.$refs.vuetable.refresh()
      //document.getElementsByClassName('vuetable-empty-result')[0].style.display = "none";
    },
    sortOrder(newval, oldVal) {
      this.fetchData((this.page = 1), [
        {
          sortField: (newval && newval[0].sortField) || 'created_at',
          direction: (newval && newval[0].direction) || 'desc',
        },
      ])
    },
  },
  destroyed() {
    if (this.selectAllField) {
      this.selectAllVentas()
    }
  },

  methods: {
    ...mapActions('ventas', [
      'fetchVentas',
      'UpdateVentas'
      /*'selectAllVentas',
      'selectedVenta',
      'deleteVenta',
      'deleteMultipleVentas',
      'setSelectAllState',*/
    ]),
    
    async updateOrder(codigo){
      this.isLoading = true
    if(this.currentUser.roles=='Vendedor'){
      this.button='Creando Orden'
    }
    if(this.currentUser.roles=='Cajero'){
      this.button='Facturando'
    }
    if(this.currentUser.roles=='Expedicion'){
      this.button='Entregando'
    } 
    if(this.currentUser.roles=='Admin'){
      this.button='Actualizando'
    }        
    let response = await this.UpdateVentas(codigo)
                console.log('Segunda Respuesta',response.data)

       if (response.data.success) {
            console.log('Tercera Respuesta')
            window.toastr['success']("Orden Actualizada")
            
            this.fetchData(this.page, this.sortOrder)
            this.isLoading = false
            if(this.currentUser.roles=='Vendedor'){
              this.button='Crear Orden'
            }
            if(this.currentUser.roles=='Cajero'){
              this.button='Facturar'
            }
            if(this.currentUser.roles=='Expedicion'){
              this.button='Entregar'
            }
            if(this.currentUser.roles=='Admin'){
              this.button='Actualizar Orden'
            }  
          }
      console.log('Update',response)
    },
    refreshTable() {
      this.$nextTick(() => {
        this.fetchData((this.page = 1), this.sortOrder)
      })
    },
    async fetchData(page, sort) {
      // this.usersList = [];
      console.log('filtro',page,sort)
      this.showNomessage = false
      let data = {
        codigo: this.filters.codigo !== null ? this.filters.codigo : '',
        marca: this.filters.marca !== null ? this.filters.marca : '',
        nombre: this.filters.nombre !== null ? this.filters.nombre : '',
        status: this.filters.status !==null ? this.filters.status : '',
        //stockact: this.filters.stockact !== null ? this.filters.stockact : '',
        

        orderByField: (sort && sort[0].sortField) || 'created_at',
        orderBy: (sort && sort[0].direction) || 'desc',
        page,
      }

      this.isRequestOngoing = false

      let response = await this.fetchVentas(data)

      this.ventasList = response.data.ventas.data
      console.log('respuesta',this.ventasList)
      if (response.data.ventas.data.length === 0) this.showNomessage = true
      this.totalCount = response.data.ventas.total

      this.isRequestOngoing = false
    },
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    async onChangePage(page) {
      this.page = page
      await this.fetchData(page, this.sortOrder)
      this.$refs.vuetable.changePage(page)
    },
    dataManager(sortOrder, pagination) {
      if (this.ventasList.length < 1) console.log('aquiiiii')
      let local = this.ventasList

      // sortOrder can be empty, so we have to check for that as well
      if (sortOrder.length > 0) {
        console.log('local',local)
        local = _.orderBy(local, sortOrder[0].sortField, sortOrder[0].direction)
        //this.fetchData(this.page,sortOrder);
      }

      pagination = this.$refs.vuetable.makePagination(
        this.totalCount,
        this.perPage
      )

      // console.log(_.slice(local, from, to)+"pp"+local+"SSS"+from+"oo"+to);
      return {
        pagination: pagination,
        data: local,
      }
    },

    setFilters() {
      this.refreshTable()
    },

    clearFilter() {
      this.filters = {
        codigo: '',
        nombre: '',
        marca: '',
        status:'',
      }
    },

    toggleFilter(value) {
      if (this.showFilters) {
        this.clearFilter()
      }

      this.showFilters = !this.showFilters
    },

    async removeVenta(id) {
      let venta = []
      venta.push(id)

      swal({
        title: this.$t('general.are_you_sure'),
        text: this.$tc('users.confirm_delete'),

        buttons: true,
        dangerMode: true,
      }).then(async (willDelete) => {
        if (willDelete) {
          let res = await this.deleteVenta(venta)

          if (res.data.success) {
            window.toastr['success'](this.$tc('ventas.deleted_message', 1))
            this.clearFilter()
            return true
          }

          if (res.data.error === 'user_attached') {
            window.toastr['error'](
              this.$tc('users.user_attached_message'),
              this.$t('general.action_failed')
            )
            return true
          }

          window.toastr['error'](res.data.message)
          return true
        }
      })
    },

    async removeMultipleUsers() {
      swal({
        title: this.$t('general.are_you_sure'),
        text: this.$tc('users.confirm_delete', 2),
        icon: '/assets/icon/trash-solid.svg',
        buttons: true,
        dangerMode: true,
      }).then(async (willDelete) => {
        if (willDelete) {
          let res = await this.deleteMultipleVentas()

          if (res.data.success || res.data.users) {
            window.toastr['success'](this.$tc('ventas.deleted_message', 2))
            this.$refs.table.refresh()
          } else if (res.data.error) {
            window.toastr['error'](res.data.message)
          }
        }
      })
    },
  },
}
</script>
